[tox]
minversion = 4.0
envlist = py3,isort,black,flake8,pylint,mypy
isolated_build = True

[testenv]
passenv =
  NO_COLOR
  PWD
  PY_COLORS

skip_install = True
allowlist_externals = poetry

commands_pre =
  poetry install --with lint

[testenv:flake8]
commands =
  poetry run flake8 {posargs} {toxinidir}/

[testenv:pylint]
commands =
  poetry run pylint {posargs} {toxinidir}/marge/ {toxinidir}/tests/

[testenv:black]
commands =
  poetry run black {posargs} {toxinidir}/

[testenv:isort]
commands =
  poetry run isort {posargs} {toxinidir}/

[testenv:mypy]
commands =
  poetry run mypy {posargs}

[testenv:poetry-lock]
commands_pre =
commands =
  poetry lock

[testenv:py3]
commands_pre =
  poetry install --with test

commands =
  poetry run pytest --cov-report term --cov-report html --cov-report xml --junitxml=test.xml {posargs}

[testenv:venv]
commands = {posargs}

[flake8]
exclude = .git,.venv,.tox,dist,doc,*egg,build,__pycache__
# We ignore the following because we use black to handle code-formatting
# E203: Whitespace before ':'
# E501: Line too long
# W503: Line break occurred before a binary operator
ignore = E203,E501,W503
